import type { OperationMiddlewareHandler } from 'executable-openapi-middleware';
import { OperationExecutionResponse } from 'executable-openapi-types';
import { Format } from 'ajv/dist/2020';
import { ResponsesObject } from 'openapi3-ts';
import { InvalidRequestBodyError } from './errors';
declare type RefResolver = ($ref: string) => Promise<unknown>;
export interface ExecutableOpenAPIMiddlewareRequestBodyOptions {
    /**
     * A JSON reference resolver that'll be used to resolve
     * JSON references found in `document`.
     *
     * If not provided, `createRouter` will use a simple resolver
     * that only resolves local JSON pointer.
     */
    documentRefResolver?: RefResolver;
    formatErrorResponse?: (error: InvalidRequestBodyError, responseObject: ResponsesObject) => OperationExecutionResponse | Promise<OperationExecutionResponse>;
    /**
     * An object with format definitions.
     */
    formats?: {
        [Name in string]?: Format;
    };
}
export declare const executableOpenAPIMiddlewareRequestBody: <TExecutionContext>({ documentRefResolver, formatErrorResponse, formats }?: ExecutableOpenAPIMiddlewareRequestBodyOptions) => OperationMiddlewareHandler<TExecutionContext>;
export {};
